diagrams-lib-1.3.0.8: Embedded domain-specific language for declarative graphics

Copyright | (c) 2011 diagrams-lib team (see LICENSE)
License | BSD-style (see LICENSE)
Maintainer | diagrams-discuss@googlegroups.com
Safe Haskell | None
Language | Haskell2010

Diagrams.ThreeD.Shapes

Description

Various three-dimensional shapes.

Synopsis

- data Ellipsoid n = Ellipsoid (Transformation V3 n)
- sphere :: (Typeable n, OrderedField n, Renderable (Ellipsoid n) b) => QDiagram b V3 n Any
- data Box n = Box (Transformation V3 n)
- cube :: (Typeable n, OrderedField n, Renderable (Box n) b) => QDiagram b V3 n Any
- data Frustum n = Frustum n n (Transformation V3 n)
- frustum :: (TypeableFloat n, Renderable (Frustum n) b) => n -> n -> QDiagram b V3 n Any
- cone :: (TypeableFloat n, Renderable (Frustum n) b) => QDiagram b V3 n Any
- cylinder :: (TypeableFloat n, Renderable (Frustum n) b) => QDiagram b V3 n Any

# Documentation

data Ellipsoid n Source

Constructors

Ellipsoid (Transformation V3 n) |

Instances

Fractional n => Transformable (Ellipsoid n) Source |
Fractional n => Renderable (Ellipsoid n) NullBackend Source |
type V (Ellipsoid n) = V3 Source |
type N (Ellipsoid n) = n Source |

sphere :: (Typeable n, OrderedField n, Renderable (Ellipsoid n) b) => QDiagram b V3 n Any Source

A sphere of radius 1 with its center at the origin.

data Box n Source

Constructors

Box (Transformation V3 n) |

Instances

Fractional n => Transformable (Box n) Source |
Fractional n => Renderable (Box n) NullBackend Source |
type V (Box n) = V3 Source |
type N (Box n) = n Source |

cube :: (Typeable n, OrderedField n, Renderable (Box n) b) => QDiagram b V3 n Any Source

A cube with side length 1, in the positive octant, with one vertex at the origin.

data Frustum n Source

Constructors

Frustum n n (Transformation V3 n) |

Instances

Fractional n => Transformable (Frustum n) Source |
Fractional n => Renderable (Frustum n) NullBackend Source |
type V (Frustum n) = V3 Source |
type N (Frustum n) = n Source |

frustum :: (TypeableFloat n, Renderable (Frustum n) b) => n -> n -> QDiagram b V3 n Any Source

A frustum of a right circular cone. It has height 1 oriented along the positive z axis, and radii r0 and r1 at Z=0 and Z=1. `cone` and `cylinder` are special cases.

cone :: (TypeableFloat n, Renderable (Frustum n) b) => QDiagram b V3 n Any Source

A cone with its base centered on the origin, with radius 1 at the base, height 1, and it's apex on the positive Z axis.

cylinder :: (TypeableFloat n, Renderable (Frustum n) b) => QDiagram b V3 n Any Source

A circular cylinder of radius 1 with one end cap centered on the origin, and extending to Z=1.